<%
Option Explicit

Class clsMobileDetection
	Private strUserAgent	' User-Agent
	Private bolMobileAgent	' boolsche Variable, ob es sich um einen mobilen Agent handelt
	Private objRegex1		' RegEx-Objekt
	Private objRegex2		' RegEx-Objekt

	Private arrServerName	' Servername separated by '.'
	Private strRedirect		' Redirect String
	Private intIdx			' Startindex fr die Analyse des Servernamens
	Private i				' Counter

							' ****************** Class-Constructor
	Private Sub Class_Initialize
		detectMobileAgent()
	End Sub

							' ****************** Erkennung des User-Agents
	Private Sub detectMobileAgent()
		bolMobileAgent = false
		
		If LCase(Request.QueryString("NoMobile")) = "true" Then	' Wenn ein Get-Parameter NoMobile=true existiert, wird kein redirect auf eine mobile Version durchgefhrt
			bolMobileAgent = false
			Response.Cookies("noMobile").Expires=date+30		' Die Auswahl wird sich fr einen spteren Besuch in einem Cookie gemerkt
			Response.Cookies("noMobile")="1"
			Exit Sub
		ElseIf LCase(Request.QueryString("Mobile")) = "true" Then ' Es soll auf jedem Fall die mobile Version aufgerufen werden
			bolMobileAgent = true
			Response.Cookies("noMobile").Expires=date-1			' Ein evtl. Cookie wird gelscht
			Exit Sub		
		End If

		If Request.Cookies("noMobile") = "1" Then				' Es ist das noMobile-Cookie gesetzt, d.h. keine Umschaltung auf die mobile Version
			bolMobileAgent = false
			Exit Sub
		End If

		strUserAgent = Request.ServerVariables("HTTP_USER_AGENT")

		Set objRegex1 = New RegExp								' mobile user-agent pattern on any position
		With objRegex1
		   .Pattern = 	"(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec" &_
						"|hiptop|iemobile|ip(hone|od)|iris|kindle|lge\ |maemo|midp|mmp|mobile.+firefox|netfront" &_
						"|opera\ m(ob|in)i|palm(\ os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian" &_
						"|treo|up\.(browser|link)|vodafone|wap|windows\ ce|xda|xiino"
		   .IgnoreCase = True
		   .Global = True
		End With
		
		Set objRegex2 = New RegExp								' mobile user-agent pattern starting with
		With objRegex2
		   .Pattern = 	"^(1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a\ wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)" &_
						"|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r\ |s\ )|avan|be(ck|ll|nq)|bi(lb|rd)" &_
						"|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)" &_
						"|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc" &_
						"|fly(\-|_)|g1\ u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp(\ i|ip)" &_
						"|hs\-c|ht(c(\-|\ |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac(\ |\-|\/)|ibro|idea|ig01|ikom|im1k|inno" &_
						"|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt(\ |\/)|klon|kpt\ |kwc\-|kyo(c|k)|le(no|xi)|lg(\ g|\/(k|l|u)" &_
						"|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef" &_
						"|mo(01|02|bi|de|do|t(\-|\ |o|v)|zz)|mt(50|p1|v\ )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)" &_
						"|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil" &_
						"|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9" &_
						"|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0" &_
						"|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v\ )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-" &_
						"|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)" &_
						"|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-|\ )|webc|whit|wi(g\ |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-)"
		   .IgnoreCase = True
		   .Global = True
		End With

		If (objRegex1.Test(strUserAgent) or objRegex2.Test(strUserAgent)) Then bolMobileAgent = true

		If InStr(Request.ServerVariables("HTTP_ACCEPT"), "application/vnd.wap.xhtml+xml") Then
		   bolMobileAgent = true
		end If
	End Sub

							' ****************** Ausgabe des Ergebnisses mobile true/false
	Public Property Get IsMobile
		IsMobile = bolMobileAgent
	End Property

							' ****************** Umleitung zu einer Subdomain http://m.meine-seiten.de
	Private Function RedirectToSubDomain(arrServerName)
		If UBound(arrServerName) <= 1 Then	'Variante http://meine-seiten.de
			intIdx = 0
		Else								'Variante http://www.meine-seiten.de
			intIdx = 1
		End if
		strRedirect = "http://m."
		For i=intIdx to uBound(arrServerName)
				strRedirect = strRedirect & arrServerName(i)
				if i <> uBound(arrServerName) Then strRedirect = strRedirect & "."
		Next
		RedirectToSubDomain = strRedirect
	End Function

							' ****************** Umleitung zu einer Mobi-Domain http://www.meine-seiten.mobi
	Private Function RedirectToMobi(arrServerName)
		If UBound(arrServerName) <= 1 Then	'Variante http://meine-seiten.de
			strRedirect = "http://www." 
		Else								'Variante http://www.meine-seiten.de
			strRedirect = "http://" 
		End if
		For i=0 to uBound(arrServerName) -1
				strRedirect = strRedirect & arrServerName(i) & "."
		Next
		strRedirect = strRedirect & "mobi"
		RedirectToMobi = strRedirect
	End Function

							' ****************** Umleitung in ein Unterverzeichnis (falls man nicht schon dort steht) http://www.meine-seiten.de/m/
	Private Function RedirectToSubDir
		
		If UBound(arrServerName) <= 1 Then	'Variante http://meine-seiten.de
			strRedirect = "http://www." & Request.ServerVariables("SERVER_NAME")
		Else								'Variante http://www.meine-seiten.de
			strRedirect = "http://" & Request.ServerVariables("SERVER_NAME")
		End if
		if LCase(Left(Request.ServerVariables("SCRIPT_NAME"),3)) <> "/m/" Then strRedirect = strRedirect & "/m" 'nur, wenn man noch nicht im mobilen Verzeichnis ist
		RedirectToSubDir = strRedirect
	End Function

							' ****************** Ausfhrung des Redirect in den Varianten SUBDOM, MOBIDOM, SUBDIR
	Public Sub RedirectMobile (strVariante)

		If IsMobile Then
			arrServerName = Split(Request.ServerVariables("SERVER_NAME"),".")
			strRedirect = ""
			Select Case UCase(strVariante)
				Case "SUBDOM"
					strRedirect = RedirectToSubDomain(arrServerName)
				Case "MOBIDOM"
					strRedirect = RedirectToMobi(arrServerName)
				Case "SUBDIR"
					strRedirect = RedirectToSubDir
			End Select

			If strRedirect <> "" Then
				strRedirect = strRedirect & Request.ServerVariables("SCRIPT_NAME")
				If Request.ServerVariables("QUERY_STRING") <> "" Then strRedirect = strRedirect & "?" & Request.ServerVariables("QUERY_STRING")
'				Response.write strRedirect
				Response.Redirect strRedirect
			Else
				Response.Write("Fehler in RedirectMobile: nur SUBDOM, MOBIDOM, SUBDIR sind als Parameter erlaubt") 
			End if
		End If
	End Sub

End Class

Dim objMobile
Set objMobile = New clsMobileDetection
'objMobile.RedirectMobile("SUBDOM")				'Bitte gewnschte Variante aktivieren
'objMobile.RedirectMobile("MOBIDOM")
'objMobile.RedirectMobile("SUBDIR")

%>